Filter (Apache Log4j 1.2.17 API)
Date: 2012-05-06

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.log4j.spi
Class Filter

    java.lang.Object
      org.apache.log4j.spi.Filter

All Implemented Interfaces:
  OptionHandler

Direct Known Subclasses:
  DenyAllFilter, LevelMatchFilter, LevelRangeFilter, StringMatchFilter

    public abstract class Filter

extends Object
implements OptionHandler

Users should extend this class to implement customized logging event filtering. Note that `Category` and `AppenderSkeleton`, the parent class of all standard appenders, have built-in filtering rules. It is suggested that you first use and understand the built-in rules before rushing to write your own custom filters.

This abstract class assumes and also imposes that filters be organized in a linear chain. The `decide(LoggingEvent)` method of each filter is called sequentially, in the order of their addition to the chain.

The `decide(LoggingEvent)` method must return one of the integer constants `DENY`, `NEUTRAL` or `ACCEPT`.

If the value `DENY` is returned, then the log event is dropped immediately without consulting with the remaining filters.

If the value `NEUTRAL` is returned, then the next filter in the chain is consulted. If there are no more filters in the chain, then the log event is logged. Thus, in the presence of no filters, the default behaviour is to log all logging events.

If the value `ACCEPT` is returned, then the log event is logged without consulting the remaining filters.

The philosophy of log4j filters is largely inspired from the Linux ipchains.

Note that filtering is only supported by the `DOMConfigurator`. The `PropertyConfigurator` does not support filters.

Since:
  0.9.0
Author:
  Ceki Gülcü

Field Summary
`static int` | `ACCEPT` The log event must be logged immediately without consulting with the remaining filters, if any, in the chain.
`static int` | `DENY` The log event must be dropped immediately without consulting with the remaining filters, if any, in the chain.
`static int` | `NEUTRAL` This filter is neutral with respect to the log event.
`Filter` | `next` Deprecated. As of 1.2.12, use `getNext()` and `setNext(org.apache.log4j.spi.Filter)` instead

Constructor Summary
`Filter()`

Method Summary
`void` | `activateOptions()` Usually filters options become active when set.
`abstract int` | `decide(LoggingEvent event)` If the decision is `DENY`, then the event will be dropped.
`Filter` | `getNext()` Return the pointer to the next filter;
`void` | `setNext(Filter next)` Set the next filter pointer.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### next

    public Filter next

  Deprecated. As of 1.2.12, use `getNext()` and `setNext(org.apache.log4j.spi.Filter)` instead
  Points to the next filter in the filter chain.

### DENY

    public static final int DENY

  The log event must be dropped immediately without consulting with the remaining filters, if any, in the chain.

  See Also:
    Constant Field Values

### NEUTRAL

    public static final int NEUTRAL

  This filter is neutral with respect to the log event. The remaining filters, if any, should be consulted for a final decision.

  See Also:
    Constant Field Values

### ACCEPT

    public static final int ACCEPT

  The log event must be logged immediately without consulting with the remaining filters, if any, in the chain.

  See Also:
    Constant Field Values

Constructor Detail

### Filter

    public Filter()

Method Detail

### activateOptions

    public void activateOptions()

  Usually filters options become active when set. We provide a default do-nothing implementation for convenience.

  Specified by:
    `activateOptions` in interface `OptionHandler`

### decide

    public abstract int decide(LoggingEvent event)

  If the decision is `DENY`, then the event will be dropped. If the decision is `NEUTRAL`, then the next filter, if any, will be invoked. If the decision is ACCEPT then the event will be logged without consulting with other filters in the chain.

  Parameters:
    `event` - The LoggingEvent to decide upon.
  Returns:
    decision The decision of the filter.

### setNext

    public void setNext(Filter next)

  Set the next filter pointer.

### getNext

    public Filter getNext()

  Return the pointer to the next filter;

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 1999-2012 Apache Software Foundation. All Rights Reserved.